#include "../src/lorem.h"
#include <stdlib.h>
#include <stdio.h>

int main(void) {
	int success = EXIT_SUCCESS;
	const char lorem[] = "Lorem ipsum dolor sit amet, consectetur adipiscing "
		"elit. Aenean tincidunt leo neque. Integer vel bibendum lectus, a "
		"vulputate dolor. Vivamus vestibulum quam ut euismod aliquet. Vivamus "
		"vel pulvinar felis, eu dictum lorem. Integer scelerisque lobortis "
		"orci nec tincidunt. Mauris vulputate ipsum non tempus tincidunt. "
		"Pellentesque nec iaculis dolor. Curabitur bibendum pretium dui "
		"euismod tincidunt. In cursus, libero et porta placerat, ante ante "
		"accumsan lacus, nec sollicitudin ex elit nec lectus. Sed nisi sem, "
		"rhoncus sed nulla et, faucibus feugiat eros.";
	struct lorem s;
	const char *a, *b, *c, *d;
	s.sub = lorem + 6, s.size = 5;
	if(!(a = lorem_dup(s))) goto catch;
	printf("a: <%s>\n", a);
	s.sub = lorem + 40, s.size = 20;
	if(!(b = lorem_dup(s))) goto catch;
	printf("a: <%s>, b: <%s>\n", a, b);
	s.sub = lorem + 80, s.size = 60;
	if(!(c = lorem_dup(s))) goto catch;
	printf("a: <%s>, b: <%s>, c: <%s>\n", a, b, c);
	s.sub = lorem + 200, s.size = 10;
	if(!(d = lorem_dup(s))) goto catch;
	printf("a: <%s>, b: <%s>, c: <%s>, d: <%s>\n", a, b, c, d);
	goto finally;
catch:
	success = EXIT_FAILURE;
	perror("text");
finally:
	lorem_();
	return success;
}
